#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>
#include <string.h>
#include <strings.h>

#include "userspace_classifier.h"


void show_rule_list ()
{
	struct list *tmp1 ;

	for (tmp1=head; tmp1!=NULL ; tmp1=tmp1->nxt)
	{
		printf ("%s\n", tmp1->data->cpuset_name);
	}
}

//file_parse: To parse the container_rulebase.txt file 
//            Which contains the information about cpusets and their fields.
//This functions returns the head pointer of the list of cpusets.

struct list * file_parse (char * file_path) 
{
	FILE *fd;
	char buff[buffer_size+1];
	char *parse_ptr, *save_ptr,*tmp;
	char delimiter[] = " ";
	struct rule_parse *rule_parser;
	struct list *tmp1,*tmp2;
	struct cpuset_list *cpuset_list_tmp;
//	struct security_context_list *security_context_list_tmp;
	head =NULL;
	
	//rule_parser=malloc(sizeof(rule_parse));

	fd = fopen(file_path,"r");
	if (fd == NULL)
	{
		perror ( "fopen" );
		printf("fopen failed for %s\n", file_path);
		exit (1);
	}
	printf("fopen successful\n");
	
	while(fgets(buff,buffer_size,fd) != NULL)
	{
		parse_ptr = buff;
		rule_parser = malloc(sizeof(struct rule_parse));

		  // check if string is empty or not
		  for (; *parse_ptr ==' ' || *parse_ptr == '\t' ||  *parse_ptr == '\v'  ; ++parse_ptr );
		  if (parse_ptr == NULL )
		  {
		  	if( feof (fd))
			{
				break ;
			}
			continue ;
		}
		// check if line is commented...
		if (*parse_ptr == '#' )
		{
			continue ;
		}
		// avoid blank lines
		if (*parse_ptr == '\0') 
		{
			continue ;
		}
		parse_ptr = buff;

		printf("value of parse_ptr%s\n",parse_ptr);
		tmp = strtok_r(parse_ptr,delimiter,&save_ptr);
		strcpy (rule_parser->cpuset_name, tmp);
		printf("value of tmp %s %s %d\n",tmp, rule_parser->cpuset_name, strlen (tmp));
	
//		strncpy(rule_parser.cpuset_name, tmp, strlen(tmp));
		
		parse_ptr = NULL;
		tmp = NULL;

		tmp = strtok_r(parse_ptr,delimiter,&save_ptr);
		if ( tmp == NULL )
		{
			printf ( "BUG\n" );
			exit (1);
		}
		strcpy(rule_parser->cpumask,tmp);
		tmp=NULL;

		tmp= strtok_r(parse_ptr,delimiter,&save_ptr);
		if ( tmp == NULL )
		{
			printf ( "BUG\n" );
			exit (1);
		}
		strcpy(rule_parser->memmask,tmp);
		tmp = NULL;

		tmp= strtok_r(parse_ptr,delimiter,&save_ptr);
		if ( tmp == NULL )
		{
			printf ( "BUG\n" );
			exit (1);
		}
		strcpy(rule_parser->cpu_exclusive,tmp); 
		tmp=NULL;

		tmp = strtok_r(parse_ptr,delimiter,&save_ptr);
		if ( tmp == NULL )
		{
			printf ( "BUG\n" );
			exit (1);
		}
		strcpy(rule_parser->mem_exclusive,tmp);
		tmp = NULL;

		tmp = strtok_r(parse_ptr,delimiter,&save_ptr);
		if ( tmp == NULL )
		{
			printf ( "BUG\n" );
			exit (1);
		}
		strcpy(rule_parser->notify_on_release,tmp); 
		tmp = NULL;

		tmp = strtok_r(parse_ptr,delimiter,&save_ptr);
		if ( tmp == NULL )
		{
			printf ( "BUG\n" );
			exit (1);
		}
		strcpy(rule_parser->mem_migrate,tmp);
		tmp = NULL;

		tmp = strtok_r(parse_ptr,delimiter,&save_ptr);
		if ( tmp == NULL )
		{
			printf ( "BUG\n" );
			exit (1);
		}
		strcpy(rule_parser->mem_pressure_enabled,tmp);
		tmp =NULL;

		tmp = strtok_r(parse_ptr,delimiter,&save_ptr);
		if ( tmp == NULL )
		{
			printf ( "BUG\n" );
			exit (1);
		}
		strcpy(rule_parser->mem_pressure,tmp);
		tmp = NULL;

		tmp = strtok_r(parse_ptr,delimiter,&save_ptr);
		if ( tmp == NULL )
		{
			printf ( "BUG\n" );
			exit (1);
		}
		strcpy(rule_parser->spread_page,tmp); 
		tmp = NULL;

		tmp = strtok_r(parse_ptr,delimiter,&save_ptr);
		if ( tmp == NULL )
		{
			printf ( "BUG\n" );
			exit (1);
		}
		strcpy(rule_parser->spread_slab,tmp); 
		
		if(head == NULL)
		{
			head = malloc(sizeof(struct list)); 
			
			head->data = rule_parser;
			head->nxt = NULL;
		}
		else
		{
			tmp1 = head;
			tmp2 = head;
			while(tmp1 != NULL)
			{
				tmp2=tmp1;
				tmp1 = tmp1->nxt;
			}
			tmp1 = malloc(sizeof(struct rule_parse));
			tmp1->data = rule_parser; 
			tmp1->nxt = NULL;
			tmp2->nxt = tmp1;

		}
	} //end of while
	
	return head;
	

}

