#ifndef __USERSPACE_CLASSIFIER_H__
#define USERSPACE_CLASSIFIER

#define buffer_size 500

#define CONTAINER_RULEBASE_PATH "/etc/container_rulebase.conf"
#define CLASSIFICATION_RULEBASE_PATH "/etc/classification_rulebase.conf"
#define LOG_FILE_PATH "./configuration/logs.txt"

///////////////////////////////////////////////////////////////////////////////////////
// container_specification.c
struct rule_parse {

	  char cpuset_name[100];
	  char cpumask[20];
	  char memmask[20];
	  char cpu_exclusive[20];
	  char mem_exclusive[20];
	  char notify_on_release[20];
	  char mem_migrate[20];
	  char mem_pressure_enabled[20];
	  char mem_pressure[20];
	  char spread_page[20];
	  char spread_slab[20];


};



struct list {

	struct rule_parse *data;
	struct list *nxt;
};

struct list * head ;
struct list * file_parse (char * file_path) ;
void show_rule_list ();


///////////////////////////////////////////////////////////////////////////////////////
// classifier.c




struct security_context_list {
        char security_context_name[100];
	struct security_context_list *security_context_nxt;
	struct list *cpuset;
};


struct security_context_list *security_context_head;
struct security_context_list *security_context_file_parser(char *file_path) ; 
struct list *find_cpuset(char *);



// search_security_context function searches given s_context
//in provided policies with considering '*' as wild-card.
//This wildcard allows you to skip some part of policy matching.
//You are allowed to specify policies in following manner.
//user_t:role_t:type_t cpuset_name1
//user_t:*:type_t	     cpuset_name2
// *:role_t:*	     cpuset_name3
// *:*:*		     cpuset_name4 # This rule matches all.

// Order of rules is important, put specific rules first, and then put generic rules

struct security_context_list * search_security_context ( char * s_context );


///////////////////////////////////////////////////////////////////////////////////////
// classification_enforcer.c
// global variables
char *mount_point ;

/*
This is the interface exposed, which will add the given PID to specified class.
This function will do all that is required to add pid to class.
If requied it will create new cpuset class.

On success, It will return 0
On failuer, it will return -1.
*/
int add_member_to_class (int pid, struct security_context_list * context_info );


#endif
